Attribute VB_Name = "Module3"
Option Explicit
Declare Function Rectangle Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal Y1 As Long, ByVal x2 As Long, ByVal Y2 As Long) As Long
Declare Function CreatePen Lib "gdi32" (ByVal nPenStyle As Long, ByVal nwidth As Long, ByVal crColor As Long) As Long
Declare Function Ellipse Lib "gdi32" (ByVal hdc As Long, ByVal x1 As Long, ByVal Y1 As Long, ByVal x2 As Long, ByVal Y2 As Long) As Long
Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Declare Function SetTextAlign Lib "gdi32" (ByVal hdc As Long, ByVal wFlags As Long) As Long
Declare Function GetTextAlign Lib "gdi32" (ByVal hdc As Long) As Long
Declare Function MoveToEx Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, lppoint As POINTAPI) As Long
Declare Function LineTo Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Declare Function PolylineTo Lib "gdi32" (ByVal hdc As Long, lppt As POINTAPI, ByVal cCount As Long) As Long
Declare Function GetTextMetrics Lib "gdi32" Alias "GetTextMetricsA" (ByVal hdc As Long, lpMetrics As TEXTMETRIC) As Long
Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Type POINTAPI
        X As Long
        Y As Long
End Type
Type TEXTMETRIC
        tmHeight As Long
        tmAscent As Long
        tmDescent As Long
        tmInternalLeading As Long
        tmExternalLeading As Long
        tmAveCharWidth As Long
        tmMaxCharWidth As Long
        tmWeight As Long
        tmOverhang As Long
        tmDigitizedAspectX As Long
        tmDigitizedAspectY As Long
        tmFirstChar As Byte
        tmLastChar As Byte
        tmDefaultChar As Byte
        tmBreakChar As Byte
        tmItalic As Byte
        tmUnderlined As Byte
        tmStruckOut As Byte
        tmPitchAndFamily As Byte
        tmCharSet As Byte
End Type
'  Pen Styles
Public Const PS_SOLID = 0
Public Const PS_DASH = 1                    '  -------
Public Const PS_DOT = 2                     '  .......
Public Const PS_DASHDOT = 3                 '  _._._._
Public Const PS_DASHDOTDOT = 4              '  _.._.._
Public Const PS_NULL = 5
Public Const TA_NOUPDATECP = 0
Public Const TA_UPDATECP = 1
Public Const TA_LEFT = 0
Public Const TA_RIGHT = 2
Public Const TA_CENTER = 6
Public Const TA_TOP = 0
Public Const TA_BOTTOM = 8
Public Const TA_BASELINE = 24
Public Const TA_MASK = (TA_BASELINE + TA_CENTER + TA_UPDATECP)
Public myPoint As POINTAPI
Public XCenter As Double, YCenter As Double, RaCenter As Double, DecCenter As Double, MxSec As Double
Public MySec As Double, FI As Double, Ga As Double, PoleRa As Double, PoleDec As Double, Azimutal As Boolean
'    
Public Sub SunDraw(hdc As Long, RaSun As Double, DecSun As Double, RadiusSun As Double)
 PoleRa = Val(Form1.Text1.Text) * 6 '   
 PoleDec = PoleRa
 RaCenter = RaSun   '   
 DecCenter = DecSun
 Call Draw_Setka(hdc, RGB(100, 100, 100)) '  
 Call Draw_Mk(hdc, RaSun, DecSun, RadiusSun, 1, RGB(250, 170, 20)) '   -   
End Sub
'     
Public Sub DrawPoints(hdc As Long, Ra2() As Double, Dec2() As Double, N As Integer)
 Dim i As Long, X As Double, Y As Double, st As String
 For i = 0 To N
  Call Draw_Mk(hdc, Ra2(i), Dec2(i), 0.005, 2, RGB(0, 0, 0)) '     
  Call RaDec_XY(Ra2(i), Dec2(i), X, Y)   '    
  st = Format(i, "0")
  Call DrawText(hdc, Int(X / Screen.TwipsPerPixelX + 5), Int(Y / Screen.TwipsPerPixelY), st) '  
 Next i
End Sub
'       (RaSun,DecSun)   RadiusSun
' hdc -   
' nwidth -  
' Color -  
Public Sub Draw_Mk(hdc As Long, RaSun As Double, DecSun As Double, RadiusSun As Double, nwidth As Long, Color As Long)
 Dim Ra_mk() As Double, Dec_mk() As Double, N As Long, i As Long
 Dim dug() As POINTAPI, Npoint As Long, X As Double, Y As Double
 Call CoordinateMK(RaSun, DecSun, RadiusSun, Ra_mk, Dec_mk, N) '      
 ReDim dug(N)
 For i = 0 To N
  Call RaDec_XY(Ra_mk(i), Dec_mk(i), X, Y) '     
  dug(i).X = Int(X + 0.5): dug(i).Y = Int(Y + 0.5)
 Next i
 Call DugaDraw(hdc, dug, N, Color, nwidth, PS_SOLID)  '  MK
End Sub
'   
' hdc -   
' Color as long
Private Sub Draw_Setka(hdc As Long, Color As Long)
 Dim WPic As Long, HPic As Long, Nline As Integer, i As Integer, Dec As Double, Ra As Double
 Dim StepDec As Double, StepRa As Double, RaG(2) As Double, dug() As POINTAPI, Npoint As Long
 Dim DecG(2) As Double
 If hdc = Form1.Picture1.hdc Then
  WPic = Form1.Picture1.Width  '   
  HPic = Form1.Picture1.Height
 End If
 If hdc = Form1.Picture2.hdc Then
  WPic = Form1.Picture2.Width
  HPic = Form1.Picture2.Height
 End If
 ' 
 MySec = PoleDec / HPic * 3600  ' arcsec on twip
 MxSec = MySec
 '   
 XCenter = WPic / 2
 YCenter = HPic / 2
 Nline = 3
 '  
 StepDec = PoleDec / (2 * Nline)
 StepRa = PoleRa / Cos(DecCenter * qq) / (2 * Nline)
 '    
 For i = -Nline To Nline
  Dec = DecCenter + i * StepDec
  RaG(1) = RaCenter - PoleRa / 2 / Cos(Dec * qq)
  RaG(2) = RaCenter + PoleRa / 2 / Cos(Dec * qq)
  Call Points_of_Setka(RaG(1), RaG(2), Dec, Dec, dug, Npoint) '   
  Call DugaDraw(hdc, dug, Npoint, Color, 1, PS_DOT)  '  
  Call DrawText(hdc, dug(Npoint - 3).X, dug(Npoint).Y, Format(Dec - DecCenter, "0.00")) ' 
 Next i
 '     
 For i = -Nline To Nline
  Ra = RaCenter + i * StepRa
  DecG(1) = DecCenter - PoleDec / 2
  DecG(2) = DecCenter + PoleDec / 2
  Call Points_of_Setka(Ra, Ra, DecG(1), DecG(2), dug, Npoint) '   
  Call DugaDraw(hdc, dug, Npoint, Color, 1, PS_DOT) '  
  Call DrawText(hdc, dug(Npoint).X, dug(Npoint).Y, Format(Ra - RaCenter, "0.00")) ' 
 Next i
End Sub
'  
' hdc -   
Private Sub DrawText(hdc As Long, X As Long, Y As Long, st As String)
 Dim dl As Long, ColorOld As Long
 dl = SetTextAlign(hdc, TA_CENTER + TA_TOP) '  
 ColorOld = SetTextColor(hdc, RGB(0, 0, 0))  '  
 dl = TextOut(hdc, X, Y, st, Len(st))  '  
 dl = SetTextColor(hdc, ColorOld)  '    
End Sub

'    (Ra1,Dec1)-(Ra2,Dec2)  
' dug(0-N) -    
Private Sub Points_of_Setka(ra1 As Double, Ra2 As Double, dec1 As Double, Dec2 As Double, _
 dug() As POINTAPI, N As Long)
 Dim i As Integer, StepRa As Double, StepDec As Double, Ra As Double, Dec As Double
 Dim X As Double, Y As Double
 N = 50
 ReDim dug(N)
 StepRa = (Ra2 - ra1) / N
 StepDec = (Dec2 - dec1) / N
 For i = 0 To N
  Ra = ra1 + i * StepRa
  Dec = dec1 + i * StepDec
  Call RaDec_XY(Ra, Dec, X, Y)
  dug(i).X = Int(X + 0.5): dug(i).Y = Int(Y + 0.5)
 Next i
End Sub
'  
' hdc -   
' lppoint(0-N) -   
' crColor - 
' nwidth -  
' TypeLine -  
Private Sub DugaDraw(hdc As Long, lppoint() As POINTAPI, N As Long, crColor As Long, nwidth As Long, TypeLine As Long)
 Dim hpen As Long
 Dim dl As Long, oldpen As Long, i As Long
 For i = 0 To N
  lppoint(i).X = lppoint(i).X / Screen.TwipsPerPixelX '     -  ,   
  lppoint(i).Y = lppoint(i).Y / Screen.TwipsPerPixelY
 Next i
 hpen = CreatePen(TypeLine, nwidth, crColor) '  
 oldpen = SelectObject(hdc, hpen)  '   
 dl = MoveToEx(hdc, lppoint(0).X, lppoint(0).Y, myPoint) '    
 dl = PolylineTo(hdc, lppoint(0), N)  '    
 dl = SelectObject(hdc, oldpen)  '   
 dl = DeleteObject(hpen)  '   
End Sub
'      (Ra,Dec)   (X,Y)
Public Sub RaDec_XY(Ra As Double, Dec As Double, X As Double, Y As Double)
 Dim q As Double, d As Double, r As Double, d0 As Double, ksi As Double, nu As Double
 Dim t1 As Double, T2 As Double, mx As Double, my As Double
 mx = Deg_Rad(MxSec / 3600)
 my = Deg_Rad(MySec / 3600)
 r = Deg_Rad(Ra - RaCenter)
 d = Deg_Rad(Dec)
 d0 = Deg_Rad(DecCenter)
 q = Cos(d0) * Cos(d) * Cos(r) + Sin(d0) * Sin(d)
 ksi = -Cos(d) * Sin(r) / q
 nu = -(Cos(d0) * Sin(d) - Sin(d0) * Cos(d) * Cos(r)) / q
 t1 = ksi: T2 = nu
 If Azimutal = True Then t1 = -t1 '     X - 
 X = XCenter + 1 / mx / Cos(Deg_Rad(Ga)) * (Cos(Deg_Rad(FI)) * t1 - Sin(Deg_Rad(FI)) * T2)
 Y = YCenter + 1 / my / Cos(Deg_Rad(Ga)) * (Sin(Deg_Rad(FI + Ga)) * t1 + Cos(Deg_Rad(FI + Ga)) * T2)
End Sub
'  x ( )  :
Private Function Deg_Rad(X As Double) As Double
 Deg_Rad = X * Pi / 180
End Function
'      (Ra0,Dec0)   Radius
Public Sub CoordinateMK(Ra0 As Double, Dec0 As Double, Radius As Double, Ra_mk() As Double, Dec_mk() As Double, N As Long)
 Dim i As Long, Ra() As Double, Dec() As Double, MatrY(3, 3) As Double, MatrZ(3, 3) As Double
 Dim r(3) As Double, ry(3) As Double, rz(3) As Double
 N = -1
 For i = 0 To 360
  N = N + 1
  ReDim Preserve Ra(N), Dec(N)
  Ra(N) = i
  Dec(N) = 90 - Radius
 Next i
 Call CreateMatrixY(90 - Dec0, MatrY) '      Y
 Call CreateMatrixZ(Ra0, MatrZ) '      Z
 ReDim Ra_mk(N), Dec_mk(N)
 For i = 0 To N
  Call CreateVector(Ra(i), Dec(i), 1, r) '    
  Call MultiplyArray(MatrY, r, ry)   '     Y
  Call MultiplyArray(MatrZ, ry, rz)  '     Z
  Call Angles_from_Vector(rz, Ra_mk(i), Dec_mk(i)) '     
 Next i
End Sub

